//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UtJuegoLogT2.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

tJuegoLogT2::tJuegoLogT2(const tJuegoLogT2& juego)
{
        hayGanador = juego.hayGanador;
        turno = juego.turno;
        tablero = new Tablero;
        *tablero = *(juego.getTablero());
}

tJuegoLogT2::tJuegoLogT2(unsigned int c, unsigned int f, Turno t)
{
        tablero = new Tablero(c, f, Jn);
        hayGanador = false;
        turno = t;
}

unsigned int tJuegoLogT2::getCols() const
{
        if(tablero != NULL)
        {
                return tablero->getCols();
        }
        else return 0;
}

unsigned int tJuegoLogT2::getFils() const
{
        if(tablero != NULL)
        {
                return tablero->getFils();
        }
        else return 0;
};

void tJuegoLogT2::reinicia(Turno turno)
{
        if(tablero != NULL)
        {
                unsigned int x = getCols(), y = getFils();
                delete tablero;
                tablero = new Tablero(x, y, Jn);
                this->turno = turno;
        }
}
//: deja el tablero vaco y el turno pasa a ser de turno.

void tJuegoLogT2::aplicaJugada(Casilla cf) throw(EJuego) //: anlogo al anterior para la jugada cf.
{
        aplicaJugada(cf.x, cf.y);
}

bool tJuegoLogT2::sePuede(Casilla cf) const throw()
{
        return sePuede(cf.x, cf.y);
} //: anlogo al anterior para la jugada cf.

Turno tJuegoLogT2::dameGanador() const throw()
{
        return turno;
} //: devuelve el ganador, que por defecto es el turno actual cuando hay un ganador.

bool tJuegoLogT2::final() const throw()
{
        return hayGanador;
} //: indica si se ha alcanza
