//---------------------------------------------------------------------------

#ifndef UtJuegoLogT2H
#define UtJuegoLogT2H

#include "UtMatriz.h"
#include "UErrores.h"
//---------------------------------------------------------------------------

enum Turno {Jn, Ja, Jb};
typedef Turno Ficha;
typedef Matriz<Ficha> Tablero;

struct Casilla
{
        unsigned int x;
        unsigned int y;
};

class tJuegoLogT2
{
public:
        tJuegoLogT2() {tablero = NULL;};
        tJuegoLogT2(const tJuegoLogT2& juego);
        tJuegoLogT2(unsigned int c, unsigned int f, Turno t);
        ~tJuegoLogT2() {delete tablero;};
        Turno getTurno() const {return turno;};
        const Tablero* getTablero() const {return tablero;};
        unsigned int getCols() const;
        unsigned int getFils() const;

        virtual void reinicia(Turno turno); //: deja el tablero vaco y el turno pasa a ser de turno.
        virtual void aplicaJugada(unsigned int c, unsigned int f) throw(EJuego) = 0; //: mtodo abstracto que aplica la jugada caracterizada por la posicin (c,f) del tablero. Si dicha jugada no es legal se lanza una excepcin.
        void aplicaJugada(Casilla cf) throw(EJuego); //: anlogo al anterior para la jugada cf.
        virtual bool sePuede(unsigned int c, unsigned int f) const throw() = 0; // : dice si la jugada caracterizada por (c,f) es una jugada legal.
        bool sePuede(Casilla cf) const throw(); //: anlogo al anterior para la jugada cf.
        virtual bool fin() const throw() = 0; //: indica si no se pueden realizar ms jugadas.
        virtual tJuegoLogT2* clona() const = 0; //: devuelve un puntero a una copia del juego actual.
        virtual Turno dameGanador() const throw(); //: devuelve el ganador, que por defecto es el turno actual cuando hay un ganador.
        bool final() const throw(); //: indica si se ha alcanza

protected:
        bool hayGanador;
        Turno turno;
        Tablero* tablero;
};

#endif
