//---------------------------------------------------------------------------

#ifndef UtJuegoOteloH
#define UtJuegoOteloH

#include "UtJuegoLogT2.h"
//---------------------------------------------------------------------------

class tJuegoOtelo:public tJuegoLogT2
{
public:
        tJuegoOtelo(const tJuegoOtelo& juego):tJuegoLogT2(juego) {this->libres = juego.libres; this->fichas[0] = juego.fichas[0]; this->fichas[1] = juego.fichas[1];};
        tJuegoOtelo(Turno t = Ja);

        virtual void aplicaJugada(unsigned int c, unsigned int f) throw(EJuego); //: mtodo abstracto que aplica la jugada caracterizada por la posicin (c,f) del tablero. Si dicha jugada no es legal se lanza una excepcin.
        virtual bool sePuede(unsigned int c, unsigned int f) const throw(); // : dice si la jugada caracterizada por (c,f) es una jugada legal.
        virtual bool fin() const throw(); //: indica si no se pueden realizar ms jugadas.
        virtual tJuegoLogT2* clona() const; //: devuelve un puntero a una copia del juego actual.

        int getFichasJa() const {return fichas[0];};
        int getFichasJb() const {return fichas[1];};

private:
        int libres;
        int fichas[2];
        bool haPasado;
        bool compruebaLinea(unsigned int c, unsigned int f) const;
        void mutaLineas(unsigned int c, unsigned int f);
};

#endif
