//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UtJugadorAutC4.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

Casilla tJugAleaC4::juega(const tJuegoLogT2& EJ) throw (EJugador)
{
        Casilla cas;
        srand(time(0));
        randomize();
        cas.x = random(EJ.getCols());
        cas.y = 0;
        return cas;
}

Casilla tJugConzC4::juega(const tJuegoLogT2& EJ) throw (EJugador)
{
        if(EJ.final()) throw EJugador();
        else
        {
                ArbolJT2 a(EJ, nivel, (FunHeuristicaT2)heuristica);
                Casilla cas = a.buscaMejorJugada();
                return cas;
        }
}

int heurisC4(const tJuegoConecta4& EJ)
{
        int contador = 0;
        unsigned int i, j;
        Turno a1, a2, a3, a4;
        for(i = 0; i < EJ.getTablero()->getCols(); i++)
        { // 4 seguidas en vertical
                for(j = 3; j < EJ.getTablero()->getFils(); j++)
                {
                        EJ.getTablero()->getElem(i, j - 3, a1);
                        EJ.getTablero()->getElem(i, j - 2, a2);
                        EJ.getTablero()->getElem(i, j - 1, a3);
                        EJ.getTablero()->getElem(i, j, a4);
                        heurisAuxC4(contador, a1, a2, a3, a4);
                }
        }
        for(i = 3; i < EJ.getTablero()->getCols(); i++)
        { // 4 seguidas en horizontal
                for(j = 0; j < EJ.getTablero()->getFils(); j++)
                {
                        EJ.getTablero()->getElem(i - 3, j, a1);
                        EJ.getTablero()->getElem(i - 2, j, a2);
                        EJ.getTablero()->getElem(i - 1, j, a3);
                        EJ.getTablero()->getElem(i, j, a4);
                        heurisAuxC4(contador, a1, a2, a3, a4);
                }
        }
        for(i = 3; i < EJ.getTablero()->getCols(); i++)
        { // 4 seguidas en diagonal 1-9
                for(j = 3; j < EJ.getTablero()->getFils(); j++)
                {
                        EJ.getTablero()->getElem(i - 3, j, a1);
                        EJ.getTablero()->getElem(i - 2, j - 1, a2);
                        EJ.getTablero()->getElem(i - 1, j - 2, a3);
                        EJ.getTablero()->getElem(i, j - 3, a4);
                        heurisAuxC4(contador, a1, a2, a3, a4);
                }
        }
        for(i = 3; i < EJ.getTablero()->getCols(); i++)
        { // 4 seguidas en diagonal 7-3
                for(j = 3; j < EJ.getTablero()->getFils(); j++)
                {
                        EJ.getTablero()->getElem(i - 3, j - 3, a1);
                        EJ.getTablero()->getElem(i - 2, j - 2, a2);
                        EJ.getTablero()->getElem(i - 1, j - 1, a3);
                        EJ.getTablero()->getElem(i, j, a4);
                        heurisAuxC4(contador, a1, a2, a3, a4);
                }
        }
        return contador;
}

void heurisAuxC4(int& cont, Turno a1, Turno a2, Turno a3, Turno a4)
{
        if((a1 != Ja) && (a2 != Ja) && (a3 != Ja) && (a4 != Ja))
        {
                int x = 0, y = 1;
                if(a1 == Jb) ++x;
                if(a2 == Jb) ++x;
                if(a3 == Jb) ++x;
                if(a4 == Jb) ++x;
                if(x > 0)
                {
                        for(x; x > 0; x--) y = y * 10;
                        cont += y;
                }
        }
        else
        {
                if((a1 != Jb) && (a2 != Jb) && (a3 != Jb) && (a4 != Jb))
                {
                        int x = 0, y = 1;
                        if(a1 == Ja) ++x;
                        if(a2 == Ja) ++x;
                        if(a3 == Ja) ++x;
                        if(a4 == Ja) ++x;
                        if(x > 0)
                        {
                                for(x; x > 0; x--) y = y * 10;
                                cont -= y;
                        }
                }
        }
}

