//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UtJugadorAutOt.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

Casilla tJugAleaOt::juega(const tJuegoLogT2& EJ) throw (EJugador)
{
        unsigned int i = 0, j = 0;
        bool sepuede = false;
        Casilla cas;
        srand(time(0));
        randomize();
        while(i < 8 && !sepuede)
        {
                while(j < 8 && !sepuede)
                {
                        sepuede = EJ.sePuede(i, j++);
                }
                j = 0;
                i++;
        }
        if(sepuede)
        {
                do
                {
                        cas.x = random(EJ.getCols());
                        cas.y = random(EJ.getFils());
                } while(!EJ.sePuede(cas.x, cas.y));
        }
        else
        {
                cas.x = 8;
                cas.y = 0;
        }
        return cas;
}

Casilla tJugConzOt::juega(const tJuegoLogT2& EJ) throw (EJugador)
{
        if(EJ.final()) throw EJugador();
        else
        {
                ArbolJT2 a(EJ, nivel, (FunHeuristicaT2)heuristica);
                Casilla cas = a.buscaMejorJugada();
                return cas;
        }
}

int heurisOt(const tJuegoOtelo& EJ)
{
        int pesos[8][8] = {
         {50, -1, 5, 2, 2, 5, -1, 50},
         {-1, -10, 1, 1, 1, 1, -10, -1},
         {5, 1, 1, 1, 1, 1, 1, 5},
         {2, 1, 1, 0, 0, 1, 1, 2},
         {2, 1, 1, 0, 0, 1, 1, 2},
         {5, 1, 1, 1, 1, 1, 1, 5},
         {-1, -10, 1, 1, 1, 1, -10, -1},
         {50, -1, 5, 2, 2, 5, -1, 50},
        };
        int contador = 0, i, j;
        Turno aux;
        for(i = 0; i < 8; i++)
        {
                for(j = 0; j < 8; j++)
                {
                        EJ.getTablero()->getElem(i, j, aux);
                        if(aux == Jb)
                        {
                                contador += pesos[i][j];
                        }
                        else if(aux == Ja)
                        {
                                contador -= pesos[i][j];
                        }
                }
        }
        return contador;
}

